DL 算缘分算得很烦闷,所以常常到体育馆去打保龄球解闷。因为他保龄球已经打了几十年了,所以技术上不成问题,于是他就想玩点新花招。
1 OOO
2 OOOO
3 O
4 OO
如上图,每个“O”代表一个瓶子。如果 DL 想要打倒 3 个瓶子就在 1 位置发球,想要打倒 4 个瓶子就在 2 位置发球。
现在他想要打倒 m 个瓶子。他告诉你每个位置的瓶子数,请你给他一个发球位置。
输入文件名为 bowling.in。
第一行包含一个正整数 n,表示位置数。
第二行包含 n 个正整数,第 i 个数。表示第 i 个位置的瓶子数,保证各个位置的瓶子数不同。
第三行包含一个正整数 Q,表示 DL 发球的次数。
第四行至文件末尾,每行包含一个正整数 m,表示 DL 需要打倒 m 个瓶子。
输出格式:
输出文件名为 bowling.out。
共 Q 行。每行包含一个整数,第 i 行的整数表示 DL 第 i 次的发球位置。若无解,则输出 0。
题目链接:http://www.luogu.org/problem/show?pid=1918#
解题思路:数据太大不能哈希,就排序后二分查找。
代码如下:
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int maxn=100000+10;
struct node
{
int x,num;
}nd[maxn];
int cmp(node a,node b)
{
return a.num<b.num;
}
int main(void)
{
int n,q;
scanf("%d",&n);
for(int i=1;i<=n;i++)
{
nd[i].x=i;
scanf("%d",&nd[i].num);
}
sort(nd,nd+n+1,cmp);
scanf("%d",&q);
for(int i=0;i<q;i++)
{
int cur,ans=0;
scanf("%d",&cur);
int lw=1,hg=n,mid;
while(lw<=hg)
{
mid=(lw+hg)/2;
if(nd[mid].num==cur)
{
ans=nd[mid].x;
break;
}
else if(nd[mid].num<cur)
lw=mid+1;
else
hg=mid-1;
}
if(ans)
printf("%d\n",ans);
else
printf("%d\n",ans );
}
}
1118



被折叠的 条评论
为什么被折叠?



